unit open;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls, QFileCtrls, QButtons, QImgList,
  libc,uXPAPI;

type
  TfrmOpen = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    lwFiles: TFileListView;
    cboFolder: TComboBox;
    sbBack: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton9: TSpeedButton;
    cboFileType: TFilterComboBox;
    cboFileName: TFileEdit;
    Image1: TImage;
    Image2: TImage;
    SpeedButton1: TSpeedButton;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lwFilesDblClick(Sender: TObject);
    procedure lwFilesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbBackClick(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure cboFolderChange(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOpen: TfrmOpen;
  Level: integer;

implementation

uses uRun;

{$R *.xfm}

procedure TfrmOpen.Button2Click(Sender: TObject);
begin
        frmOpen.Close;
end;

procedure TfrmOpen.FormCreate(Sender: TObject);
var
 PPWRec  : PPasswordRecord;
 uid     : Integer;

begin

     Level:=0;
     lwFiles.Directory.FileMask:= cboFileType.Mask;

     uid := getuid;
     PPWRec := getpwuid(uid);
     if PPWRec^.pw_name ='root' then cboFolder.Text := '/'+PPWRec^.pw_name
     else cboFolder.Text := '/home/'+PPWRec^.pw_name;
     lwFiles.Directory.Location:=cboFolder.Text;
     cboFolder.Items.Add(cboFolder.Text);
     cboFolder.ItemIndex:=0;

     Label1.Font.Assign(Label2.font);

end;

procedure TfrmOpen.lwFilesDblClick(Sender: TObject);
var
  sr: TSearchRec;
  FileAttrs: Integer;
  FilePath: string;
begin
    sbBack.Glyph:=Image1.Picture.Bitmap;
    FilePath:=lwFiles.Directory.Location+lwFiles.Selected.Caption;
    if FindFirst(FilePath,faAnyFile+faDirectory, sr) = 0 then begin
        FindClose(sr);
        frmOpen.Close;
    end
    else begin
        cboFolder.Text:=FilePath;
        cboFolder.Items.Add(FilePath);
        Level:=Level+1;
        cboFolder.ItemIndex:=Level;
    end;



end;

procedure TfrmOpen.lwFilesClick(Sender: TObject);
begin
    try cboFileName.Text:=lwFiles.Selected.Caption;
    except
    end;
    
end;

procedure TfrmOpen.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    try
       RunDlg.cbOpen.Text:=lwFiles.Directory.Location+lwFiles.Selected.Caption;
       RunDlg.cbOpen.Items.Add(lwFiles.Directory.Location+lwFiles.Selected.Caption);
       Action:=caFree;
    except
    end;



end;

procedure TfrmOpen.sbBackClick(Sender: TObject);
begin
     try
           Level:=Level-1;
           cboFolder.ItemIndex:=Level;
           cboFolder.Text:=cboFolder.Items[Level];
     except
     end;

end;

procedure TfrmOpen.SpeedButton4Click(Sender: TObject);
begin
     lwFiles.ViewStyle:= vsList;
end;

procedure TfrmOpen.SpeedButton1Click(Sender: TObject);
var
    NewColumn: TListColumn;
begin

      with lwFiles do
      begin
          ViewStyle:= vsReport;
          Columns.Clear;
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Name';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Size';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Type';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Date Modified';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Attributes';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Owner';
          NewColumn:=Columns.Add;
          NewColumn.Caption:='Group';
      end;


end;

procedure TfrmOpen.SpeedButton8Click(Sender: TObject);
var
   FilePath:String;
begin
     FilePath:=XPAPI.getSysInfo(siUserDir)+'/.xpde/Desktop/';
     cboFolder.Items.Add(FilePath);
     lwFiles.Directory.Location:=FilePath;
     cboFolder.Text:=FilePath;
end;

procedure TfrmOpen.cboFolderChange(Sender: TObject);
begin
    try
       lwFiles.Directory.Location:=cboFolder.Text;

    except

    end;
end;

procedure TfrmOpen.SpeedButton5Click(Sender: TObject);
var
   FilePath:String;
begin
     FilePath:=XPAPI.getSysInfo(siUserDir)+'/.xpde/My Documents/';
     cboFolder.Items.Add(FilePath);
     lwFiles.Directory.Location:=FilePath;
     cboFolder.Text:=FilePath;
end;

procedure TfrmOpen.SpeedButton7Click(Sender: TObject);
var
   PPWRec  : PPasswordRecord;
   uid     : Integer;
begin
     uid := getuid;
     PPWRec := getpwuid(uid);
     if PPWRec^.pw_name ='root' then cboFolder.Text := '/'+PPWRec^.pw_name
     else cboFolder.Text := '/home/'+PPWRec^.pw_name;
     lwFiles.Directory.Location:=cboFolder.Text;
     cboFolder.Items.Add(cboFolder.Text);
     cboFolder.ItemIndex:=0;

end;

procedure TfrmOpen.SpeedButton6Click(Sender: TObject);
var
   FilePath:String;
begin
     FilePath:=XPAPI.getSysInfo(siUserDir)+'/.xpde/Control Panel/';
     cboFolder.Items.Add(FilePath);
     lwFiles.Directory.Location:=FilePath;
     cboFolder.Text:=FilePath;

end;

procedure TfrmOpen.SpeedButton9Click(Sender: TObject);
var
   FilePath:String;
begin
     FilePath:=XPAPI.getSysInfo(siUserDir)+'/.xpde/SmbNetwork/';
     cboFolder.Items.Add(FilePath);
     lwFiles.Directory.Location:=FilePath;
     cboFolder.Text:=FilePath;

end;

end.
